From f8ea533150b3d82df03bdf2899d4ffa7ea374cd0 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Dec 27 2020 21:07:37 +0000
Subject: [PATCH 1816/2232] Merge pull request #601 from dtolnay/slice


Obtain Slice iterator stride in a way that works for opaque types
---

diff --git a/gen/src/builtin.rs b/gen/src/builtin.rs
index d43038b..409a5d1 100644
--- a/gen/src/builtin.rs
+++ b/gen/src/builtin.rs
@@ -64,6 +64,7 @@ pub(super) fn write(out: &mut OutFile) {
         include.iterator = true;
         include.type_traits = true;
         builtin.friend_impl = true;
+        builtin.layout = true;
         builtin.panic = true;
     }
 
@@ -141,6 +142,12 @@ pub(super) fn write(out: &mut OutFile) {
         writeln!(out, "class Opaque;");
     }
 
+    if builtin.rust_slice {
+        out.next_section();
+        writeln!(out, "template <typename T>");
+        writeln!(out, "::std::size_t size_of();");
+    }
+
     ifndef::write(out, builtin.rust_string, "CXXBRIDGE1_RUST_STRING");
     ifndef::write(out, builtin.rust_str, "CXXBRIDGE1_RUST_STR");
     ifndef::write(out, builtin.rust_slice, "CXXBRIDGE1_RUST_SLICE");
diff --git a/include/cxx.h b/include/cxx.h
index 12b2d5c..8ca1a12 100644
--- a/include/cxx.h
+++ b/include/cxx.h
@@ -689,7 +689,7 @@ template <typename T>
 typename Slice<T>::iterator Slice<T>::begin() const noexcept {
   iterator it;
   it.pos = const_cast<typename std::remove_const<T>::type *>(this->ptr);
-  it.stride = sizeof(T);
+  it.stride = size_of<T>();
   return it;
 }
 

